#ifndef IPLUGIN_H
#define IPLUGIN_H

#include <QString>
#include <QWidget>
#include <QtPlugin>
#include <QJsonObject>

#include "service.h"

class IPlugin
{

public:
    IPlugin() {
        m_ui = NULL;
    }

    virtual ~IPlugin() {  }
    virtual QString pluginName() = 0;
    virtual QString pluginId() = 0;
    virtual QString pluginDescription() = 0;
    virtual void init(const QJsonObject &metaData) = 0;
    virtual QWidget *ui() {
        return m_ui;
    }
    template<class T>
    Service<T> *service() {
        return (Service<T>*)m_service;
    }

protected:
    QWidget *m_ui;
    void *m_service;
};

#define PluginInterface_iid "cz.itsolved.prodejna.IPlugin"

Q_DECLARE_INTERFACE(IPlugin, PluginInterface_iid)

#endif // IPLUGIN_H
